<?xml version="1.0" encoding="UTF-8" ?>
<!-- ======================================================== -->
<!--  callact.cfm inserts a new phone number into the         -->
<!--  database, then prompts the user to enter a new number,  -->
<!--  record and send a new message, or end the call.         -->
<!-- ======================================================== -->
<callxml>
<block label="postphone">
  <!--- =============================================================== --->
  <!---  If the user's account is established from earlier scripts ...  --->
  <!--- =============================================================== --->
  <cfif IsDefined("userid")>
	<!--- ================================================ --->
	<!---  If callact.cfm received a new phone number ...  --->
	<!--- ================================================ --->	
	<cfif IsDefined("newphone") and #newphone# gte 1000000>
	  <!--- ============================================== --->
	  <!---  Check it against the existing phone numbers.  --->
	  <!--- ============================================== --->
	  <cfquery name="rpscheck" datasource="Broadcaster">
	    select * from Recipients where (UserID = #userid# and Phone = '#newphone#')
	  </cfquery>
		
	  <cfoutput query="rpscheck">
	    <cfset found="true">
	  </cfoutput>
			
	  <cfif IsDefined("found")>
	    <!-- ======================================== -->
	    <!--  If the phone number is already listed,  -->
	    <!--  send the user back to choose another.   -->
	    <!-- ======================================== -->
	    <block label="found">
	      <playaudio format="audio/wav" value="oldphone.wav" termdigits="#" cache="no" />				
	      <goto value="callrps.cfm" submit="*" method="post" cache="no" />
	    </block>
			
	  <cfelse>
	    <!-- ========================================== -->
	    <!--  Insert the new number into the database,  -->
	    <!--  and read the user a list of options.      -->
	    <!-- ========================================== -->
	    <cfquery name="rpsinsert" datasource="Broadcaster">
	      insert into Recipients (UserID, Phone, Answer) values (#userid#, #newphone#, 'no')
	    </cfquery>	
			
	    <menu label="select" repeat="2" format="audio/wav" value="newmenu.wav" 
		  termdigits="123" maxtime="20s">
		  
		  <wait value="20s" termdigits="123" /> 
					
		  <!-- ============================== -->
		  <!--  "1" to enter new recipients.  -->
		  <!-- ============================== -->
		  <ontermdigit value="1">
			<goto value="callrps.cfm" submit="*" method="post" cache="no" />
		  </ontermdigit>
			
		  <!-- ======================================= -->
		  <!--  "2" to record and send a new message.  -->
		  <!-- ======================================= -->
		  <ontermdigit value="2">
			<goto value="callrecord.cfm" submit="*" method="post" cache="no" />
		  </ontermdigit>
			
		  <!-- ====================== -->
		  <!--  "3" to end the call.  -->
		  <!-- ====================== -->
		  <ontermdigit value="3">
			<playaudio format="audio/wav" value="thankyou.wav" termdigits="#" cache="no" />
			<hangup />
			<onhangup></onhangup>
		  </ontermdigit>
		</menu>
			
		<!-- ================================================= -->
		<!--  If they don't do anything at all, end the call.  -->
		<!-- ================================================= -->
		<onmaxtime>
		  <playaudio format="audio/wav" value="thankyou.wav" termdigits="#" cache="no" />
		  <hangup />		
		  <onhangup></onhangup>
		</onmaxtime>
	  </cfif>
			
	<!--- ======================================== --->
	<!---  If the phone number is invalid, send    --->
	<!---  them back to callrps.cfm to try again.  --->
	<!--- ======================================== --->
	<cfelse>
	  <block label="goback">
		<playaudio format="audio/wav" value="notphone.wav" termdigits="#" cache="no" />
		<goto value="callrps.cfm" submit="*" method="post" cache="no" />
	  </block>
	</cfif>
		
  <!--- ======================================== --->
  <!---  If callact.cfm did not received a user  --->
  <!---  ID, send them back to try again.        --->
  <!--- ======================================== --->
  <cfelse>
	<playaudio format="audio/wav" value="invalid.wav" termdigits="#" cache="no" />
	<cflocation url="calllogin.cfm">
  </cfif>		
  <onhangup></onhangup>
</block>
</callxml>
