<?xml version="1.0" encoding="UTF-8" ?>
<!-- ============================================================== -->
<!--  calllogin.cfm is the "gatekeeper" page that takes a caller's  -->
<!--  PIN and passes it to callmenu.cfm for verification. If the    -->
<!--  caller is new, they are first directed to callpin.cfm.        -->
<!-- ============================================================== -->
<callxml>
<block label="login">
  <!-- ================================================== -->
  <!--  Answer and greet the caller, then read in a four  -->
  <!--  digit PIN named "userpin" (plus the "termdigit"   -->
  <!--  pound key, which is not included in "userpin").   -->
  <!-- ================================================== -->
  <!-- <answer /> -->
  <inputdigits label="calllogin" repeat="1" var="userpin" 
    maxdigits="5" format="audio/wav" value="greeting.wav" 
	termdigits="*#" cleardigits="true" includetermdigit="false" 
	maxtime="15s" maxsilence="5s" />
		
  <!-- ======================================================== -->
  <!--  If the user presses the star key (*), prompt them for   -->
  <!--  a new PIN and pass it to callpin.cfm for verification.  -->
  <!-- ======================================================== -->
  <ontermdigit value="*">
  <block label="new">
	<inputdigits label="newlogin" repeat="1" var="newpin" 
      maxdigits="5" format="audio/wav" value="pin.wav"
	  termdigits="#" cleardigits="false" includetermdigit="false" 
	  maxtime="15s" maxsilence="5s" />
		
	<ontermdigit value="#">
	  <goto value="callpin.cfm" submit="newpin" method="post" cache="no" />
	</ontermdigit>
		
	<!-- ===================================== -->
	<!--  If they enter more than four digits  -->
	<!--  or pause for too long, start over.   -->
	<!-- ===================================== -->
	<onmaxdigits>
	  <playaudio format="audio/wav" value="invalid.wav" cache="no" /> 
	  <goto value="calllogin.cfm" submit="" method="post" cache="no" />
	</onmaxdigits>
	
	<onmaxsilence>
	  <goto value="calllogin.cfm" submit="" method="post" cache="no" />
	</onmaxsilence>
		
	<!-- ================================================= -->
	<!--  If they don't do anything at all, end the call.  -->
	<!-- ================================================= -->
	<onmaxtime>
	  <hangup />
	  <onhangup></onhangup>
	</onmaxtime>
	
  </block>
  </ontermdigit>
	
  <!-- ====================================================================== -->
  <!--  If the user enters a four (or fewer) digit pin and presses the pound  -->
  <!--  key (#), pass "userpin" to callmenu.cfm, which checks the PIN and     -->
  <!--  then directs the user to record a message or enter new recipients.    -->
  <!-- ====================================================================== -->
  <ontermdigit value="#">
	<goto value="callmenu.cfm" submit="userpin" method="post" cache="no" />
  </ontermdigit>
	
  <!-- ===================================== -->
  <!--  If they enter more than four digits  -->
  <!--  or pause for too long, start over.   -->
  <!-- ===================================== -->
  <onmaxdigits>
	<playaudio format="audio/wav" value="invalid.wav" cache="no" /> 
	<goto value="calllogin.cfm" submit="" method="post" cache="no" />
  </onmaxdigits>
	
  <onmaxsilence>
	<goto value="calllogin.cfm" submit="" method="post" cache="no" />
  </onmaxsilence>
	
  <!-- ================================================= -->
  <!--  If they don't do anything at all, end the call.  -->
  <!-- ================================================= -->
  <onmaxtime>
 	<hangup />
	<onhangup></onhangup>
  </onmaxtime>
  
  <onhangup></onhangup>
</block>
</callxml>

