<?xml version="1.0" encoding="UTF-8" ?>
<!-- ======================================================== -->
<!--  callmenu.cfm gives the user the choice of entering new  -->
<!--  recipients or recording and sending out a new message.  -->
<!-- ======================================================== -->
<callxml>
<block label="menu">
  <!--- ===================================== --->
  <!---  If callmenu.cfm received a PIN from  --->
  <!---  calllogin.cfm (or callpin.cfm) ...   --->
  <!--- ===================================== --->
  <cfif IsDefined("userpin")>
	<!--- ================================= --->
	<!---  Look up their user ID and name.  --->
	<!--- ================================= --->
	<cfif Not IsDefined("userid") and Not IsDefined("name")>
	  <cfquery name="validpin" datasource="Broadcaster">
		select * from Users where PIN = #userpin#
	  </cfquery>
			
	  <cfoutput query="validpin">
		<cfset userid = "#UserID#">
		<assign var="userid" value="#userid#" />
		<cfset name = #Trim(FirstName & " " & LastName)#>
		<assign var="name" value="#name#" />
	  </cfoutput>
	</cfif>
		
	<cfif IsDefined("userid")>
	  <playaudio format="audio/wav" value="hello.wav" termdigits="" cache="no" />
			
	  <cfif #name# is not "Broadcaster">
	    <!-- ==================================================== -->
	    <!--  Reading back the name stored with the PIN provides  -->
	    <!--  an extra layer of verification, in case the caller  -->
	    <!--  accidentally entered someone else's PIN.            -->
	    <!-- ==================================================== -->
		<cfoutput><text> #name# </text></cfoutput>
	  </cfif> 
			
	  <!-- ============================== -->
	  <!--  Tell the user their options.  -->
	  <!-- ============================== -->
	  <menu label="select" repeat="2" format="audio/wav" value="mainmenu.wav" 
		termdigits="12" maxtime="20s">
		
		<wait value="20s" termdigits="12" />
						
	    <!-- ============================== -->
	    <!--  "1" to enter new recipients.  -->
	    <!-- ============================== -->
	    <ontermdigit value="1">
	  	  <goto value="callrps.cfm" submit="*" method="post" cache="no" />
	    </ontermdigit>
				
	    <!-- ======================================= -->
	    <!--  "2" to record and send a new message.  -->
	    <!-- ======================================= -->
	    <ontermdigit value="2">
	 	  <goto value="callrecord.cfm" submit="*" method="post" cache="no" />
	    </ontermdigit>
	  </menu>
				
	  <!-- ================================================= -->
	  <!--  If they don't do anything at all, end the call.  -->
	  <!-- ================================================= -->
	  <onmaxtime>
		<playaudio format="audio/wav" value="thankyou.wav" termdigits="#" cache="no" />
		<hangup />
		<onhangup></onhangup>
	  </onmaxtime>
			
	<!--- ========================================== --->
	<!---  If the PIN doesn't belong to an account,  --->
	<!---  send them back to try again.              --->
	<!--- ========================================== --->
	<cfelse>
	  <playaudio format="audio/wav" value="invalid.wav" cache="no" /> 
	  <cflocation url="calllogin.cfm">	
	</cfif>
		
  <!--- ============================================= --->
  <!---  If callmenu.cfm did not received a new four  --->
  <!---  digit PIN, send them back to try again.      --->
  <!--- ============================================= --->
  <cfelse>
	<playaudio format="audio/wav" value="invalid.wav" cache="no" /> 
	<cflocation url="calllogin.cfm">	
  </cfif>
  <onhangup></onhangup>
</block>
</callxml>

