<?xml version="1.0" encoding="UTF-8" ?>
<!-- ======================================================================= -->
<!--  callpin.cfm registers a new PIN and sends the caller to callmenu.cfm.  -->
<!-- ======================================================================= -->
<callxml>
<block label="newuser">
  <!--- ================================================== --->
  <!---  If callpin.cfm received a new four digit PIN ...  --->
  <!--- ================================================== --->
  <cfif IsDefined("newpin") and #newpin# gte 1000 and #newpin# lte 9999>
 	<!--- ===================================== --->
	<!---  Check it against the existing PINs.  --->
	<!--- ===================================== --->
	<cfquery name="verifypin" datasource="Broadcaster">
	  select * from Users where PIN = #newpin#
	</cfquery>
		
	<cfoutput query="verifypin">
	  <cfset ispin="#PIN#">
	</cfoutput>
		
	<!--- ======================================== --->
	<!---  If the new PIN is already in use, send  --->
	<!---  the user back to choose another PIN.    --->
	<!--- ======================================== --->
	<cfif IsDefined("ispin")>
	  <playaudio format="audio/wav" value="sorry.wav" cache="no" />
	  <goto value="calllogin.cfm" submit="" method="post" cache="no" />
			
	<!--- ================================================================ --->
	<!---  If not, insert a new account into the database, repeat the new  --->
	<!---  PIN back to the caller, and then direct them to callmenu.cfm.   --->
	<!--- ================================================================ --->
	<cfelse>
	  <cfquery name="newuser" datasource="Broadcaster">
		insert into Users (FirstName, PIN) values ('Broadcaster', #newpin#) 
	  </cfquery>
			
	  <cfoutput> 
		<cfset userpin = #newpin#>
		<assign var="userpin" value="#userpin#" />
				
		<playaudio format="audio/wav" value="newpin.wav" cache="no" />
		<playnumber format="digits" value="#userpin#" />
			
		<goto value="callmenu.cfm" submit="*" method="post" cache="no" />
	  </cfoutput>
	</cfif>
		
  <!--- ============================================ --->
  <!---  If callpin.cfm did not received a new four  --->
  <!---  digit PIN, send them back to try again.     --->
  <!--- ============================================ --->
  <cfelse>
	<playaudio format="audio/wav" value="invalid.wav" cache="no" /> 
	<cflocation url="calllogin.cfm">
  </cfif>		
  <onhangup></onhangup>			
</block>
</callxml>

