<?xml version="1.0" encoding="UTF-8" ?>
<!-- ============================================================================== -->
<!--  callprocess.cfm looks up the caller's list of recipients in the database and  -->
<!--  initiates a session of callsend.xml with each recipient's phone number.       -->
<!-- ============================================================================== -->
<callxml>
<block label="process">
<!--- =========================================== --->
<!---  Set the variable "batch" to the number of  --->
<!---  recipients Broadcaster should try to call  --->
<!---  at a time. 10 is the recommended number.   --->
<!--- =========================================== --->
<cfset batch="10">

  <!--- =========================================================== --->
  <!---  Execute only if a value was received from callrecord.cfm.  --->
  <!--- =========================================================== --->
  <cfif IsDefined("userid")>
	<!-- ========================================= -->
	<!--  The message is saved via FTP. A query    -->
	<!--  retrieves the http path to the message.  -->
	<!-- ========================================= -->
	<cfquery name="ftp" datasource="Broadcaster">
	  select Msgpath from FTP
	</cfquery>
	
	<cfoutput query="ftp">
	  <assign var="msgpath" value="#Msgpath#" />
	</cfoutput>
	
	<!--- ====================================================== --->
	<!---  Specify the number of times to send the message out.  --->
	<!--- ====================================================== --->
	<cfloop index="loopcount" from="1" to="2">
	  <!--- ==================================================== --->
	  <!---  Generate a list of recipients who have not already  --->
	  <!---  answered (everyone, the first time through).        --->
	  <!--- ==================================================== --->
	  <cfquery name="recipients" datasource="Broadcaster">
		select * from Recipients where (UserID = #userid# and Answer = 'no')
	  </cfquery>
		
	  <!--- ========================================================= --->
	  <!---  The calls go out in batches of #batch#. First, check     --->
	  <!---  the number of recipients to see if it's divisible by     --->
	  <!---  #batch#. If not, perform an "integer division" and then  --->
	  <!---  add 1 for the decimal, so that the result "loopmax" is   --->
	  <!---  an integer. "loopmax" is the total number of batches.    --->
	  <!--- ========================================================= --->
	  <cfif (recipients.recordcount mod #batch#) is 0>
		<cfset loopmax = recipients.recordcount/#batch#>
	  <cfelse>
		<cfset loopmax = recipients.recordcount\#batch# + 1>
	  </cfif>
		
	  <cfset limitOne=1>
	  <cfset limitTwo=#batch#>
		
	  <!--- ================================== --->
	  <!---  Run "loopmax" number of batches.  --->
	  <!--- ================================== --->
	  <cfloop index="i" from="1" to="#loopmax#">
		<!--- ============================================== --->
		<!---  Run through the calls in batches of #batch#.  --->
		<!--- ============================================== --->
		<cfloop query="recipients" startrow="#limitOne#" endrow="#limitTwo#">
		<cfoutput>
		  <cfset phone="#Phone#">
		  <block label="runcalls">
			<assign var="parentsession" value="$session.ID;" />
			<assign var="phone" value="#phone#" />
			<assign var="name" value="$name;" />
					
			<!-- ================================================ -->
			<!--  Run a session of callsend.xml, which will call  -->
			<!--  #Name#'s phone number and play the message.     -->
			<!-- ================================================ -->
			<run value="callsend.xml" submit="*" method="post" var="childsession" cache="no" />
						
			<!-- ========================================================== -->
			<!--  If callsend.xml returns a value of "success", meaning     -->
			<!--  the call was answered, run CallUpdate.cfm to update       -->
			<!--  the database so that Answer is 'yes' for this recipient.  -->
			<!-- ========================================================== -->
			<onexternalevent value="success">
			  <assign var="rpsid" value="#UniqueID#" />
			  <run value="callupdate.cfm" submit="*" method="post" var="updatesession" cache="no" />
			</onexternalevent>
					
			<!-- ======================================================= -->
			<!--  If callsend.xml returns a value of "failure" (for a    -->
			<!--  variety of reasons), some action could be taken here.  -->
			<!-- ======================================================= -->
			<onexternalevent value="failure">
			</onexternalevent>	
			
			<wait value="5s" />
		  </block>
		  </cfoutput>
		</cfloop>
					
		<!--- ========================================================= --->
		<!---  Increase these variables for the next batch of #batch#.  --->
		<!--- ========================================================= --->
		<cfset limitOne = limitOne + #batch#>
		<cfset limitTwo = limitTwo + #batch#>
	  </cfloop>
	  <wait value="300s" />
	</cfloop>
		
	<!--- ======================================== --->
	<!---  Afterward, reset the Answer flag for    --->
	<!---  every recipient to "no" for next time.  --->
	<!--- ======================================== --->
	<cfquery name="reset" datasource="Broadcaster">
	  update Recipients set Answer='no' where UserID=#userid#
	</cfquery>
	
  <cfelse>
	<playaudio format="audio/wav" value="invalid.wav" cache="no" /> 
	<cflocation url="calllogin.cfm">
  </cfif>
  <onhangup></onhangup>
</block>
</callxml>

