<?xml version="1.0" encoding="UTF-8" ?>
<!-- =============================================================================== -->
<!--  callrecord.cfm records the caller's message and passes it to callprocess.cfm.  -->
<!-- =============================================================================== -->
<callxml>
<block label="record">
  <!--- =============================================================== --->
  <!---  If the user's account is established from earlier scripts ...  --->
  <!--- =============================================================== --->
  <cfif IsDefined("userid")>
	<!--- ============================================================== --->
	<!---  The message is saved via FTP. This query retrieves the path,  --->
	<!---  which contains the username and password, from the database.  --->
	<!--- ============================================================== --->
	<cfquery name="ftp" datasource="Broadcaster">
	  select FTPpath from FTP
	</cfquery>
	
	<cfoutput query="ftp">
	  <!-- ====================================================== -->
	  <!--  Record their message and send it to callprocess.cfm.  -->
	  <!-- ====================================================== -->
	  <playaudio format="audio/wav" value="record.wav" termdigits="##" cache="no" />
				
	  <!-- =============================== -->
	  <!--  Record and store the message.  -->
	  <!-- =============================== -->
	  <recordaudio format="audio/wav" value="#FTPpath#/msg#userid#.wav" termdigits="##" 
		maxtime="90s" maxsilence="5s" beep="true" />
			
	  <ontermdigit value="##">
		<run value="callprocess.cfm" submit="*" method="post" cache="no" />
		<!-- ==================================== -->
		<!--  Thank the caller and end the call.  -->
		<!-- ==================================== -->
		<playaudio format="audio/wav" value="thankyou.wav" termdigits="##" cache="no" />				
		<hangup />
		<onhangup></onhangup>
	  </ontermdigit>
			
	  <!-- ================================= -->
	  <!--  If an error occurs, start over.  -->
	  <!-- ================================= -->
	  <onerror>
		<playaudio format="audio/wav" value="error.wav" termdigits="##" cache="no" />				
		<goto value="callrecord.cfm" submit="*" method="post" cache="no" />
	  </onerror>
	</cfoutput>

  <!-- ========================================================== -->
  <!--  If the PIN is invalid, send them back to the login page.  -->
  <!-- ========================================================== -->
  <cfelse>
	<playaudio format="audio/wav" value="invalid.wav" cache="no" /> 
	<cflocation url="calllogin.cfm">	
  </cfif>
  <onhangup></onhangup>
</block>
</callxml>
