<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Broadcaster</title>
<!-- ====================================================================== -->
<!--  recipinfo.cfm executes a variety of queries, depending on the values  -->
<!--  sent by userinfo.cfm, and then presents a ColdFusion grid of the      -->
<!--  user's recipients that can be added to, deleted from, and edited.     -->
<!-- ====================================================================== -->
<link rel=stylesheet type="text/css" href="broadcaster.css">
<script language="javascript">
  //===============================================================
  // RemoveBad() is from Microsoft's Knowledge Base article Q25985
  // courtesy of ColdFusion Developer's Journal, Volumn 2, Issue 7
  // "Safe Scripting" by James A. Brannan
  //===============================================================
  function RemoveBad(strTemp) {
	strTemp = strTemp.replace(/\<|\>|\"|\%|\;|\(|\)|\&|\+/g, "");
	return strTemp;
  } // RemoveBad()
  
  function isNum(theValue) {
	for(i = 0; i < theValue.length; i++) {
	  if(theValue.charAt(i) < "0") { return false; }
	  if(theValue.charAt(i) > "9") { return false; }
	} // for
	return true;
  }	// isNum()
  
  function validgrid(recipients, recipientsgrid, theValue) {
	if(theValue != "") {
	  theValue = RemoveBad(theValue);
	  return true;
	} // if
	else { return false; }
  } // validgrid()
</script>
</head>

<body>
<table width=100% cellspacing=0>
  <tr>
	<td height=100><img src="background_curve.gif" alt=""></td>
	<td height=100><a href="http://www.voxeo.com">
	  <img src="logo.gif" border=0 alt="voxeo"></a></td>
	<td height=100 align="right"><img src="top_slogan.gif" 
	  alt="bringing the power of the web to the telephone"></td>
  </tr>
  <tr>
	<td></td>
	<td colspan=2>
	  <a href="weblogin.cfm"><h2><big>B</big>ROADCASTER</h2></a>
	</td>
  </tr>
  <tr>
	<td colspan=2></td>
	<td>
	<!--- ========================================================== --->
	<!--- "flag" is generated by userinfo.cfm (or recipaction.cfm).  --->
	<!--- ========================================================== --->
	<cfif IsDefined("form.flag")>
	  <!--- ==================================================== --->
	  <!---  If they are new, insert their information into the  --->
	  <!---  database and retrieve their field key, "UserID".    --->
	  <!--- ==================================================== --->
	  <cfif #form.flag# is "new">
		<cfquery name="insertuser" datasource="Broadcaster">
		  insert into Users (FirstName, LastName, Phone, Email, PIN) 
			values ('#form.first#', '#form.last#', #form.phone#, '#form.email#', #form.pin#)		
		</cfquery>
				
		<cfquery name="findnewuser" datasource="Broadcaster">
		  select * from Users where (PIN = #form.pin# and Email = '#form.email#')		
		</cfquery>
		
		<cfoutput query="findnewuser">
		  <cfset userid="#UserID#">
		</cfoutput>
				
	  <!--- ============================================================== --->
	  <!---  If they asked for help, check the information they provided.  --->
	  <!--- ============================================================== --->
	  <cfelseif #form.flag# is "help">
		<cfquery name="finduser" datasource="Broadcaster">
		  select * from Users where (Phone = '#form.phone#' and Email = '#form.email#')		
		</cfquery>
				
		<!--- ====================================================== --->
		<!---  If it's valid, display their name (for confirmation)  --->
		<!---  and their PIN, and retrieve their UserID.             --->
		<!--- ====================================================== --->
		<cfoutput query="finduser">
		  <cfset userid="#UserID#">
		  <b>Hello, #FirstName# #LastName#.<br>
		  Your PIN is <big>#PIN#</big>.</b><br><br>
		</cfoutput>
		
		<!--- ========================================= --->
		<!---  If not, send them back to weblogin.cfm.  --->
		<!--- ========================================= --->
		<cfif Not IsDefined("userid")>
		  <cflocation url="weblogin.cfm?notinfo=true">
		</cfif>
		
	  <!--- =========================================== --->
	  <!---  recipaction.cfm can call this page again,  --->
	  <!---  if they want to "view" their changes.      --->
	  <!--- =========================================== --->
	  <cfelseif #form.flag# is "view">
		<cfset userid="#form.userid#">
				
	  <!--- ====================================== --->
	  <!---  Otherwise, update their information.  --->
	  <!--- ====================================== --->
	  <cfelse>
		<cfquery name="updateuser" datasource="Broadcaster">
		  update Users set FirstName = '#form.first#', LastName = '#form.last#', 
		    Phone = #form.phone#, Email = '#form.email#' where UserID = #form.flag#	
		</cfquery>
			
		<cfset userid="#form.flag#">
	  </cfif>
			
	<!--- =============================================== --->
	<!---  If someone goes to this page without entering  --->
	<!---  a PIN, send them back to the log-in page.      --->
	<!--- =============================================== --->
	<cfelse>
	  <cflocation url="weblogin.cfm">
	</cfif>
			
	<!--- ======================================================== --->
	<!---  Every valid action on this page results in a "userid".  --->
	<!--- ======================================================== --->
	<cfif IsDefined("userid")>	
	  <cfquery name="recipients" datasource="Broadcaster">
	    select * from Recipients where UserID = #userid#
	  </cfquery>
			
	  <!--- ============================================================== --->
	  <!---  Display the names and phone numbers of the user's recipients  --->
	  <!---  in a ColdFusion grid. Edit, insert and delete are enabled.    --->
	  <!--- ============================================================== --->
	  <small>Enter each phone number as a 10-digit number <br>
	  with no punctuation, i.e. 8315551234</small><br><br>
	  <cfform name="recipients" method="post" action="recipaction.cfm">
	    <cfgrid name="recipientsgrid" 
		        query="recipients" 
				selectmode="edit" 
				insert="Yes" 
				delete="Yes" 
				gridlines="Yes" 
				colheaders="Yes" 
				onvalidate="validgrid">
	      <cfgridcolumn name="UniqueID" display="No">
	      <cfgridcolumn name="Name" display="Yes" header="Name" required="yes">
	      <cfgridcolumn name="Phone" display="Yes" header="Phone" required="yes">
	    </cfgrid><br><br>
	    <cfoutput><input type="hidden" name="userid" value="#userid#"></cfoutput>
	    <input type="submit" value="Update">
	  </cfform>	
			
	<cfelse>
	  <cflocation url="weblogin.cfm">
	</cfif>
	</td>
  </tr>
</table>
</body>
</html>
